//+------------------------------------------------------------------+
//|                                                FT_Parabolic SAR_EMA.mq4 |
//|                            FORTRADER.RU, , ftyuriy@gmail.com |
//|                          http://FORTRADER.RU, Parabolic SAR     +  |
//+------------------------------------------------------------------+
#property copyright "FORTRADER.RU, , ftyuriy@gmail.com"
#property link      "http://FORTRADER.RU, MACD + Parabolic SAR"

/*  49   FORTRADER.Ru.     MACD. 
: http://finfile.ru/index.php/files/get/EYLOCZ45tW/sarma2.zip, http://finfile.ru/index.php/files/get/f_rINNIekN/sarma.zip
 :http://finfile.ru/index.php/files/get/hKV6K515_n/sar-ma-eurusd1h.set 
:http://fxnow.ru/group_discussion_view.php?group_id=49&grouptopic_id=269&grouppost_id=2682#post_2682 
 : http://www.fortrader.ru/arhiv.php
49 : http://www.fortrader.ru/
*/

extern int ema1_period = 10 ; 
extern int ema2_period = 25 ; 
extern int ema3_period = 50 ; 

// 
extern double stepfast=0.02; 
extern double stepfast15m=0.02; 
extern double maximumfast=0.2;

 int SL=1500;
 int TP=1500;
extern int mn=1;
int err;
extern int MG=564651;
extern double Lots=0.01;
extern int maxpos=1;

int bars;
int start()
{
  if(bars!=Bars)
  {   
      bars=Bars;
      OpenPattern();
  }
return(0);
}

int okbuy,oksell;

int OpenPattern()
  {
  double op,sl,tp;
  
   // 
   double fastsar=iSAR(NULL,0,stepfast,maximumfast,1);
   double fastsar15=iSAR(NULL,15,stepfast15m,maximumfast,1);
  
  double ma1=iMA(NULL,0,ema1_period,0,MODE_EMA,PRICE_CLOSE,1);
  double ma2=iMA(NULL,0,ema2_period,0,MODE_EMA,PRICE_CLOSE,1);
  double ma3=iMA(NULL,0,ema3_period,0,MODE_EMA,PRICE_CLOSE,1);
  
  if(ma1<ma2 && ma1<ma3){okbuy=1;}
  if(ma1>ma2 && ma1>ma3){oksell=1;}


  if(oksell==1 && ma1<ma2 && ma1<ma3 && fastsar>Close[1] && fastsar15>Close[1] && CountPos(0)<maxpos )
  {
   op=Bid;if(SL>0){sl=Bid+SL*Point*mn;}if(TP>0){tp=Bid-TP*Point*mn;}
   err=OrderSend(Symbol(),OP_SELL,Lots,NormalizeDouble(op,Digits),3,NormalizeDouble(sl,Digits),NormalizeDouble(tp,Digits),"4 FORTRADER.RU",MG,0,Red);
   if(err<0){Print("OrderSend()-   OP_SELL.  op "+op+" sl "+sl+" tp "+tp+" "+GetLastError());return(-1);}
   oksell=0;
  }
  
  if(okbuy==1 && ma1>ma2 && ma1>ma3  && fastsar<Close[1] && fastsar15<Close[1]  && CountPos(1)<maxpos )
  {
   op=Ask;if(SL>0){sl=Ask-SL*Point*mn;}if(TP>0){tp=Ask+TP*Point*mn;}
   err=OrderSend(Symbol(),OP_BUY,Lots,NormalizeDouble(op,Digits),3,NormalizeDouble(sl,Digits),NormalizeDouble(tp,Digits),"6 FORTRADER.RU",MG,0,Red);
   if(err<0){Print("OrderSend()-   OP_BUY.  op "+op+" sl "+sl+" tp "+tp+" "+GetLastError());return(-1);}
   okbuy=0;
  }
  
  if(ma1<ma2 && ma1<ma3 ){_OrderClose(1);}
  if(ma1>ma2 && ma1>ma3){_OrderClose(0);}
  
 return(err);
 }
  
//  .
int CountPos(int type) 
{// http://fxnow.ru/blog.php?user=Yuriy&blogentry_id=66

int i;
int col;
int count=0 ;
for( i=0; i<=OrdersTotal(); i++)
{
if(OrderSelect(i,SELECT_BY_POS)==true)
{
if(OrderType()==OP_BUY && OrderSymbol()==Symbol() && type==1 && OrderMagicNumber()==MG ){count++;}
if(OrderType()==OP_SELL && OrderSymbol()==Symbol() && type==0 && OrderMagicNumber()==MG ){count++;}
}
} 
return(count);
}





int _OrderClose(int type)
   {int err;

   for(int i=1; i<=OrdersTotal(); i++)          
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) 
        {
         if(OrderType()==OP_BUY && OrderSymbol()==Symbol() && type==1 && OrderMagicNumber()==MG )
         {
          err=OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); 
          if(err<0){Print("OrderClose()-    OP_BUY.  OrderTicket "+OrderTicket()+" OrderLots() "+OrderLots()+" Bid "+Bid+" "+GetLastError());return(-1);}
         }
         if(OrderType()==OP_SELL && OrderSymbol()==Symbol() && type==0 && OrderMagicNumber()==MG)
         {
          err=OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); 
          if(err<0){Print("OrderClose()-    OP_SELL.  OrderTicket "+OrderTicket()+" OrderLots() "+OrderLots()+" Ask "+Ask+" "+GetLastError());return(-1);}
         }
        }
       }
   return(0);
   }
   

